
import { world, system } from "@minecraft/server";

system.beforeEvents.watchdogTerminate.subscribe(eventData => {
	console.error("watchdog = " + eventData.terminateReason +
		" trying to cancel crash")
	eventData.cancel = true
})

const prefix = '-tp';

let reqList = [];
let tick = 0;
let reqTimeOut = 30;

function yourCommand(command, arg, text, player) {
	const playerName = player.name || player.nameTag;

	let targetPlayer = testTargetName(arg) || "*";
	let argName = getArgName(arg) || "";
	let checkTarget = reqList.find(i => i[0].startsWith(targetPlayer)) || ["*", "*", 0];
	let checkPlayer = reqList.find(i => i[0] == playerName) || ["*", "*", 0];
	switch (command) {
		case 'r':
		case 'req':
		case 'request':
			if (targetPlayer == playerName) return runCmd(`tellraw "${playerName}" {"rawtext":[{"text": "§r §ckendine tp atamazsın" }]}`);
			if (targetPlayer == "*") return runCmd(`tellraw "${playerName}" {"rawtext":[{"text": "§r §e@${argName} §coyuncusu bulunamadı" }]}`);
			if (checkPlayer[0] == playerName) return runCmd(`tellraw "${playerName}" { "rawtext": [ { "text": "§r §czaten istek gönderdiniz.\n§r §clutfen onceki isteginizi tamamlayın(30 saniye bekleyiniz)" } ] }`);
			runCmd(`tellraw "${targetPlayer}" { "rawtext": [ { "text": "§r §e${playerName} §asana tp isteği gönderdi.\n§aKabul etmek icin -tpa @oyuncu_ismi yazın.\n§ciptal etmek için -tpd @oyuncu_ismi yazın." } ] }`);
			runCmd(`tellraw "${playerName}" {"rawtext":[{"text": "§r §asenin yanına tp olmak istiyor §e@${targetPlayer}" }]}`);
			reqList.push([playerName, targetPlayer, reqTimeOut]);
			break;

		case 'a':
		case 'acc':
		case 'accept':
			if (targetPlayer == playerName) return runCmd(`tellraw "${playerName}" {"rawtext":[{"text": "§r §ckendine tp atamazsın" }]}`);
			if (targetPlayer == "*") return runCmd(`tellraw "${playerName}" {"rawtext":[{"text": "§r §e@${argName} §coyuncusu bulunamadı" }]}`);
			if (checkTarget[1] != playerName) return runCmd(`tellraw "${playerName}" { "rawtext": [ { "text": "§r §e@${targetPlayer} §csana istek göndermedi" } ] }`);
			let playerList = world.getAllPlayers()
			let target = playerList.find(i => i.name.startsWith(targetPlayer) || i.nameTag.startsWith(targetPlayer))
			runCmdEntity("particle minecraft:egg_destroy_emitter", target)
			runCmdEntity("particle minecraft:end_chest", target)
			runCmdEntity(`tp @s ${player.location.x} ${player.location.y + 0.5} ${player.location.z} true`, target)
			runCmd(`tellraw "${checkTarget[0]}" { "rawtext": [ { "text": "§r §atp isteğini §e@${playerName}§a kabul etti" } ] }`);
			runCmd(`tellraw "${playerName}" { "rawtext": [ { "text": "§r  §e@${checkTarget[0]} §aoyuncunun tp isteğini kabul ettin" } ] }`);
			runCmdEntity("particle minecraft:end_chest", player)
			player.runCommandAsync(`playsound mob.endermen.portal @a ${Math.floor(player.location.x) + 0.5} ${Math.floor(player.location.y) + 0.5} ${Math.floor(player.location.z) + 0.5} 1`)
			reqList.splice(reqList.indexOf(checkTarget), 1);
			break;

		case 'd':
		case 'dec':
		case 'decline':
			if (targetPlayer == playerName) return runCmd(`tellraw "${playerName}" {"rawtext":[{"text": "§r §ckendine tp isteği atamazsın" }]}`);
			if (targetPlayer == "*") return runCmd(`tellraw "${playerName}" {"rawtext":[{"text": "§r §e@${argName} §coyuncusu bulunamadı" }]}`);
			if (checkTarget[1] != playerName) return runCmd(`tellraw "${playerName}" { "rawtext": [ { "text": "§r §e@${targetPlayer} §csana tp isteği atmadı" } ] }`);
			runCmd(`tellraw "${checkTarget[0]}" { "rawtext": [ { "text": "§r §e@${playerName} §atp isteğiniz iptal etti" } ] }`);
			runCmd(`tellraw "${playerName}" { "rawtext": [ { "text": "§r §e@${checkTarget[0]} §aoyuncunun isteğini iptal ettin" } ] }`);
			reqList.splice(reqList.indexOf(checkTarget), 1);
			break;

		case 'l':
		case 'list':
			if (checkPlayer[0] == playerName) {
				runCmd(`tellraw "${playerName}" { "rawtext": [ { "text": "§r  §e@${checkPlayer[1]} §boyuncusuna tp istegi attın" } ] }`);
			} else {
				runCmd(`tellraw "${playerName}" { "rawtext": [ { "text": "§r §bsenin kimseye tp isteğin yok"}]}`);
			}

			let adaReq = false
			reqList.forEach(i => {
				if (i[1] == playerName) {
					adaReq = true
					runCmd(`tellraw "${playerName}" { "rawtext": [ { "text": "§r §e@${i[0]} §asana tp isteği attı" } ] }`);
				}
			})
			if (!adaReq) runCmd(`tellraw "${playerName}" { "rawtext": [ { "text": "§r §bsana atılan tp isteği bulunamadı"}]}`);
			break;

		case 'h':
		case 'help':
			let cmdTxt = [
				"tpr ",
				"tpa ",
				"tpd ",
				"tpl ",
				"tph "
			];
			let infoTxt = [
				"tp istegi atmak için",
				"tp istegi kabul etmek için",
				"tp istegi iptal etmek için",
				"sana veya senin tp isteklerinin listesini görmek için",
				"tp komutlarını görmek için"
			];
			let helpTxt = [
				`${prefix}r @\\"oyuncu ismi\\"`,
				`${prefix}a @\\"oyuncu ismi\\"`,
				`${prefix}d @\\"oyuncu ismi\\"`,
				`${prefix} list`,
				`${prefix} help`
			];
			for (var i in cmdTxt) {
				runCmd(`tellraw "${playerName}" {"rawtext":[{"text": "§6---------------------§r\n... §b${cmdTxt[i]} §c${infoTxt[i]}\n§e${helpTxt[i]}\n§6---------------------§r" }]}`);
			}
			break;
		default:
	}
}

async function onTick() {
	tick += 1
	if (tick < 20) {
		return
	} else {
		tick = 0
	}
	if (reqList.length >= 1) {
		reqList.forEach(i => {
			i[2] -= 1;
			if (i[2] < 1) {
				runCmd(`tellraw "${i[0]}" { "rawtext": [ { "text": "§r §e@${i[0]} §ctp zaman asimi" } ] }`);
				runCmd(`tellraw "${i[1]}" { "rawtext": [ { "text": "§r §e@${i[0]} §ctp zaman asimi" } ] }`);
			}
		})
		reqList = reqList.filter(c => c[2] > 0)
	}
}

function testTargetName(arg) {
	if (arg.length == 0 || arg == null) return "*";
	let tPlayer = getArgName(arg);
	if (tPlayer.length == 0 || tPlayer == "") return "*";
	let playerList = world.getAllPlayers()
	let target = playerList.find(i => i.name.startsWith(tPlayer) || i.nameTag.startsWith(tPlayer))
	if (target) {
		return target.name || target.nameTag
	} else {
		return "*"
	}
}

function getArgName(arg) {
	let tPlayer = arg.join(" ").replace(/@/g, "").replace(/"/g, "");
	return tPlayer.length === 0 ? "" : tPlayer
}

world.afterEvents.playerLeave.subscribe(name => {
	reqList.forEach(i => {
		if (i[0].startsWith(name)) {
			runCmd(`tellraw "${i[1]}" { "rawtext": [ { "text": "§r §e@${i[0]} §bbaglanti kesildi, tp istek iptal edildi" } ] }`);
		}
		if (i[1].startsWith(name)) {
			runCmd(`tellraw "${i[0]}" { "rawtext": [ { "text": "§r §e@${i[1]} §bbaglanti kesildi, tp istek iptal edildi" } ] }`);
		}
	})
	reqList = reqList.filter(i => i != name);
})

system.run(function tick(eventData) {
	system.run(tick)
	onTick()
})

function runCmd(cmd, dim) {
	return world.getDimension(dim || "overworld").runCommandAsync(cmd);
}

function runCmdEntity(cmd, entity) {
	return entity.runCommandAsync(cmd);
}


world.beforeEvents.chatSend.subscribe(msg => {
	if (msg.message.startsWith(prefix)) {
		let args_ = msg.message.slice(prefix.length).trim().split(' '); //split command & argument from prefix
		let command = args_.shift().toLowerCase(); //split command and command argument
		msg.cancel = true; //cancel chat
		const player = msg.sender; //get the player that using this chat)
		const text = msg.message; //get original message
		yourCommand(command, args_, text, player);
	} else if (msg.sender.hasTag("mute")) {
		msg.cancel = true;
	} else {
		msg.cancel = true;
		const getRanks = (string) => {
			return msg.sender.getTags().filter(tag => tag.startsWith(string)).map(tag => tag.substring(string.length)).join("-§r-") ?? "§dOyuncu"
		}
		const rank = getRanks("rank:").length <= 0 ? "§dOyuncu"
			: getRanks("rank:").replaceAll("-§r-", "§r§l§7}§r" + "§r§l§7{§r")
		const formated = `§r§l§7{§r${rank}§r§l§7}§r §e${msg.sender.name}§r: §7${msg.message}`
		world.sendMessage(formated)
	}
})
